<template>
  <a-form :form="form">
    <div style="width: 250px">
      <a-select
        v-if="editing"
        v-decorator="['org']"
        :default-active-first-option="true"
        :show-arrow="true"
        :filter-option="false"
        :get-popup-container="triggerNode => triggerNode.parentNode"
        :not-found-content="null"
        :loading="loading"
        :value="value"
        @search="handleSearch"
        @change="handleChange"
        @blur="handleBlur"
        show-search
      >
        <a-icon slot="suffixIcon" type="caret-down" class="srp-darkest" />

        <a-select-option
          v-for="d in organizations"
          :key="d.id"
          :value="d.id"
        >
          {{ d.companyName }}
        </a-select-option>
      </a-select>

      <a-button v-else @click="changeOrg" type="link">
        <ellipsis :length="60" tooltip>
          {{ organizationName || (loading ? '' : '選択する') }}
        </ellipsis>
      </a-button>
    </div>
  </a-form>
</template>

<script>
export default {
  data () {
    return {
      organizations: [],
      editing: false,
      loading: false,
      value: null,
      showProfile: false
    }
  },
  computed: {
    organizationName () {
      const { org } = this.$route.query
      const organization = this.organizations.find(o => o.id === org)
      return organization ? organization.companyName : null
    }
  },
  beforeCreate () {
    this.form = this.$form.createForm(this, { first: true })
  },
  created () {
    console.log('getOrganizations created')
    this.getOrganizations()
    this.value = this.$route.query.org
  },
  methods: {
    changeOrg () {
      this.editing = true
    },
    handleSearch (value) {
      console.log('handleSearch:', value)
      this.getOrganizations(value)
    },
    handleChange (value, option) {
      this.editing = false
      this.value = value
      //   this.$router.push({ path: '/seekers', query: { org: value } })
      window.location.href = `/seekers?org=${value}`
    },
    handleBlur () {
      this.editing = false
    },
    async getOrganizations (value) {
      // eslint-disable-next-line no-unused-vars
      this.loading = true
      try {
        const params = {
          ...(value && {
            filter: {
              companyName: {
                matchPhrasePrefix: value
              }
            }
          }),

          limit: 20
        }
        const { items } = await this.$siteApi.searchRecruiters(params)

        console.log(items)
        this.organizations = items
      } catch (error) {
        console.log(error)
      }
      this.loading = false
    }
  }
}
</script>

<style></style>
